#ifndef EFL_GENERATED_EDJE_EDIT_HH
#define EFL_GENERATED_EDJE_EDIT_HH

#include <Eo.h>
#include <Eo.hh>

extern "C"
{
#include "edje_edit.eo.h"
}

#include "edje.eo.hh"

struct edje_edit
      : edje
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit edje_edit(Eo* eo)
      : edje(eo)
   {}

   edje_edit(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : edje_edit(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   edje_edit(edje_edit const& other)
      : edje(eo_ref(other._eo_ptr()))
   {}

   ~edje_edit() {}

   static Eo_Class const* _eo_class()
   {
      return(EDJE_EDIT_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(EDJE_EDIT_CLASS, _p._eo_raw, eo_constructor());
   }

};
namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::edje_edit >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ::edje_edit >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::edje_edit>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< ::edje_edit >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::edje_edit, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

template<>
struct extension_inheritance< ::edje_edit>
{
   template <typename T>
   struct type
   {
      operator ::edje_edit() const
      {
         return ::edje_edit(eo_ref(static_cast<T const*>(this)->_eo_ptr()));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::edje_edit>)
{
   return (EDJE_EDIT_CLASS);
}

} } }
#endif // EFL_GENERATED_EDJE_EDIT_HH

